VERSION 5.00
Begin VB.UserControl ComboBoxEx 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.TextBox txt 
      Height          =   285
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   1095
   End
   Begin VB.ComboBox cmb 
      Height          =   315
      Left            =   0
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   240
      Width           =   1095
   End
End
Attribute VB_Name = "ComboBoxEx"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const CB_SHOWDROPDOWN = &H14F
Private Const CB_GETDROPPEDSTATE = &H157

'Event Declarations:
Event ItemSelect() 'MappingInfo=cmb,cmb,-1,Click
Attribute ItemSelect.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event Click() 'MappingInfo=txt,txt,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=txt,txt,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=txt,txt,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=txt,txt,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=txt,txt,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=txt,txt,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=txt,txt,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=txt,txt,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."
Event Change() 'MappingInfo=txt,txt,-1,Change
Attribute Change.VB_Description = "Occurs when the contents of a control have changed."
Event DropDown() 'MappingInfo=cmb,cmb,-1,DropDown
Attribute DropDown.VB_Description = "Occurs when the list portion of a ComboBox control is about to drop down."
Event Scroll() 'MappingInfo=cmb,cmb,-1,Scroll
Attribute Scroll.VB_Description = "Occurs when you reposition the scroll box on a control."

Const m_def_Dropped = False
'Default Property Values:
'Const m_def_Dropped = False

Dim m_Dropped As Boolean
'Property Variables:
'Dim m_Dropped As Boolean
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = txt.BackColor
End Property
Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    txt.BackColor() = New_BackColor
    PropertyChanged "BackColor"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = txt.ForeColor
End Property
Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    txt.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = txt.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    txt.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = txt.Font
End Property
Public Property Set Font(ByVal New_Font As Font)
    Set txt.Font = New_Font
    PropertyChanged "Font"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = txt.BorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    txt.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property
Private Sub Redraw()
With txt
    .Top = 0
    .Left = 0
    .Height = Height
    .Width = Width
End With
With cmb
    .Top = txt.Height - cmb.Height
    .Left = 0
    .Width = Width
End With
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    UserControl.Refresh
End Sub
Private Sub txt_Click()
    RaiseEvent Click
    If Not Dropped Then Dropped = True
End Sub
Private Sub txt_DblClick()
    RaiseEvent DblClick
End Sub
Private Sub txt_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub
Private Sub txt_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub
Private Sub txt_KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyDown
            Dropped = True
        Case vbKeyEscape
            Dropped = False
    End Select
    
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub
Private Sub txt_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub
Private Sub txt_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub
Private Sub txt_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,AddItem
Public Sub AddItem(ByVal Item As String, Optional ByVal Index As Variant)
Attribute AddItem.VB_Description = "Adds an item to a Listbox or ComboBox control or a row to a Grid control."
    cmb.AddItem Item, Index
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,Alignment
Public Property Get Alignment() As Integer
Attribute Alignment.VB_Description = "Returns/sets the alignment of a CheckBox or OptionButton, or a control's text."
    Alignment = txt.Alignment
End Property

Public Property Let Alignment(ByVal New_Alignment As Integer)
    txt.Alignment() = New_Alignment
    PropertyChanged "Alignment"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,Appearance
Public Property Get Appearance() As Integer
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
    Appearance = txt.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As Integer)
    txt.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

Private Sub txt_Change()
    RaiseEvent Change
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,Clear
Public Sub Clear()
Attribute Clear.VB_Description = "Clears the contents of a control or the system Clipboard."
    cmb.Clear
End Sub

Private Sub cmb_DropDown()
    RaiseEvent DropDown
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,FontBold
Public Property Get FontBold() As Boolean
Attribute FontBold.VB_Description = "Returns/sets bold font styles."
    FontBold = txt.FontBold
End Property

Public Property Let FontBold(ByVal New_FontBold As Boolean)
    txt.FontBold() = New_FontBold
    PropertyChanged "FontBold"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,FontItalic
Public Property Get FontItalic() As Boolean
Attribute FontItalic.VB_Description = "Returns/sets italic font styles."
    FontItalic = txt.FontItalic
End Property

Public Property Let FontItalic(ByVal New_FontItalic As Boolean)
    txt.FontItalic() = New_FontItalic
    PropertyChanged "FontItalic"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,FontStrikethru
Public Property Get FontStrikethru() As Boolean
Attribute FontStrikethru.VB_Description = "Returns/sets strikethrough font styles."
    FontStrikethru = txt.FontStrikethru
End Property

Public Property Let FontStrikethru(ByVal New_FontStrikethru As Boolean)
    txt.FontStrikethru() = New_FontStrikethru
    PropertyChanged "FontStrikethru"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,FontUnderline
Public Property Get FontUnderline() As Boolean
Attribute FontUnderline.VB_Description = "Returns/sets underline font styles."
    FontUnderline = txt.FontUnderline
End Property

Public Property Let FontUnderline(ByVal New_FontUnderline As Boolean)
    txt.FontUnderline() = New_FontUnderline
    PropertyChanged "FontUnderline"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,HideSelection
Public Property Get HideSelection() As Boolean
Attribute HideSelection.VB_Description = "Specifies whether the selection in a Masked edit control is hidden when the control loses focus."
    HideSelection = txt.HideSelection
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,ItemData
Public Property Get ItemData(ByVal Index As Integer) As Long
Attribute ItemData.VB_Description = "Returns/sets a specific number for each item in a ComboBox or ListBox control."
    ItemData = cmb.ItemData(Index)
End Property

Public Property Let ItemData(ByVal Index As Integer, ByVal New_ItemData As Long)
    cmb.ItemData(Index) = New_ItemData
    PropertyChanged "ItemData"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,List
Public Property Get List(ByVal Index As Integer) As String
Attribute List.VB_Description = "Returns/sets the items contained in a control's list portion."
    List = cmb.List(Index)
End Property

Public Property Let List(ByVal Index As Integer, ByVal New_List As String)
    cmb.List(Index) = New_List
    PropertyChanged "List"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,ListCount
Public Property Get ListCount() As Integer
Attribute ListCount.VB_Description = "Returns the number of items in the list portion of a control."
    ListCount = cmb.ListCount
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,ListIndex
Public Property Get ListIndex() As Integer
Attribute ListIndex.VB_Description = "Returns/sets the index of the currently selected item in the control."
    ListIndex = cmb.ListIndex
End Property

Public Property Let ListIndex(ByVal New_ListIndex As Integer)
    cmb.ListIndex() = New_ListIndex
    PropertyChanged "ListIndex"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,NewIndex
Public Property Get NewIndex() As Integer
Attribute NewIndex.VB_Description = "Returns the index of the item most recently added to a control."
    NewIndex = cmb.NewIndex
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,Locked
Public Property Get Locked() As Boolean
Attribute Locked.VB_Description = "Determines whether a control can be edited."
    Locked = txt.Locked
End Property

Public Property Let Locked(ByVal New_Locked As Boolean)
    txt.Locked() = New_Locked
    PropertyChanged "Locked"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,ScrollBars
Public Property Get ScrollBars() As Integer
Attribute ScrollBars.VB_Description = "Returns/sets a value indicating whether an object has vertical or horizontal scroll bars."
    ScrollBars = txt.ScrollBars
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,SelLength
Public Property Get SelLength() As Long
Attribute SelLength.VB_Description = "Returns/sets the number of characters selected."
    SelLength = txt.SelLength
End Property

Public Property Let SelLength(ByVal New_SelLength As Long)
    txt.SelLength() = New_SelLength
    PropertyChanged "SelLength"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,SelStart
Public Property Get SelStart() As Long
Attribute SelStart.VB_Description = "Returns/sets the starting point of text selected."
    SelStart = txt.SelStart
End Property

Public Property Let SelStart(ByVal New_SelStart As Long)
    txt.SelStart() = New_SelStart
    PropertyChanged "SelStart"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,SelText
Public Property Get SelText() As String
Attribute SelText.VB_Description = "Returns/sets the string containing the currently selected text."
    SelText = txt.SelText
End Property

Public Property Let SelText(ByVal New_SelText As String)
    txt.SelText() = New_SelText
    PropertyChanged "SelText"
End Property

Private Sub cmb_Scroll()
    RaiseEvent Scroll
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,Sorted
Public Property Get Sorted() As Boolean
Attribute Sorted.VB_Description = "Indicates whether the elements of a control are automatically sorted alphabetically."
    Sorted = cmb.Sorted
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,Text
Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
    Text = txt.Text
End Property
Public Property Let Text(ByVal New_Text As String)
    txt.Text() = New_Text
    PropertyChanged "Text"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=txt,txt,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
    ToolTipText = txt.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    txt.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,BackColor
Public Property Get BackColorCombo() As OLE_COLOR
Attribute BackColorCombo.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColorCombo = cmb.BackColor
End Property

Public Property Let BackColorCombo(ByVal New_BackColorCombo As OLE_COLOR)
    cmb.BackColor() = New_BackColorCombo
    PropertyChanged "BackColorCombo"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmb,cmb,-1,ForeColor
Public Property Get ForeColorCombo() As OLE_COLOR
Attribute ForeColorCombo.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColorCombo = cmb.ForeColor
End Property
Public Property Let ForeColorCombo(ByVal New_ForeColorCombo As OLE_COLOR)
    cmb.ForeColor() = New_ForeColorCombo
    PropertyChanged "ForeColorCombo"
End Property
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
Dim i As Integer

    txt.BackColor = PropBag.ReadProperty("BackColor", &H80000005)
    txt.ForeColor = PropBag.ReadProperty("ForeColor", &H80000008)
    txt.Enabled = PropBag.ReadProperty("Enabled", True)
    Set txt.Font = PropBag.ReadProperty("Font", Ambient.Font)
    txt.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    txt.Alignment = PropBag.ReadProperty("Alignment", 0)
    txt.Appearance = PropBag.ReadProperty("Appearance", 1)
    txt.FontBold = PropBag.ReadProperty("FontBold", 0)
    txt.FontItalic = PropBag.ReadProperty("FontItalic", 0)
    txt.FontStrikethru = PropBag.ReadProperty("FontStrikethru", 0)
    txt.FontUnderline = PropBag.ReadProperty("FontUnderline", 0)
    
    cmb.ListIndex = PropBag.ReadProperty("ListIndex", 0)
    txt.Locked = PropBag.ReadProperty("Locked", False)
    txt.SelLength = PropBag.ReadProperty("SelLength", 0)
    txt.SelStart = PropBag.ReadProperty("SelStart", 0)
    txt.SelText = PropBag.ReadProperty("SelText", "")
    txt.Text = PropBag.ReadProperty("Text", "Text1")
    txt.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    cmb.BackColor = PropBag.ReadProperty("BackColorCombo", &H80000005)
    cmb.ForeColor = PropBag.ReadProperty("ForeColorCombo", &H80000008)
    m_Dropped = PropBag.ReadProperty("Dropped", m_def_Dropped)
End Sub
Private Sub UserControl_Resize()
Redraw
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
Dim i As Integer

    Call PropBag.WriteProperty("BackColor", txt.BackColor, &H80000005)
    Call PropBag.WriteProperty("ForeColor", txt.ForeColor, &H80000008)
    Call PropBag.WriteProperty("Enabled", txt.Enabled, True)
    Call PropBag.WriteProperty("Font", txt.Font, Ambient.Font)
    Call PropBag.WriteProperty("BorderStyle", txt.BorderStyle, 1)
    Call PropBag.WriteProperty("Alignment", txt.Alignment, 0)
    Call PropBag.WriteProperty("Appearance", txt.Appearance, 1)
    Call PropBag.WriteProperty("FontBold", txt.FontBold, 0)
    Call PropBag.WriteProperty("FontItalic", txt.FontItalic, 0)
    Call PropBag.WriteProperty("FontStrikethru", txt.FontStrikethru, 0)
    Call PropBag.WriteProperty("FontUnderline", txt.FontUnderline, 0)

    Call PropBag.WriteProperty("ListIndex", cmb.ListIndex, 0)
    Call PropBag.WriteProperty("Locked", txt.Locked, False)
    Call PropBag.WriteProperty("SelLength", txt.SelLength, 0)
    Call PropBag.WriteProperty("SelStart", txt.SelStart, 0)
    Call PropBag.WriteProperty("SelText", txt.SelText, "")
    Call PropBag.WriteProperty("Text", txt.Text, "Text1")
    Call PropBag.WriteProperty("ToolTipText", txt.ToolTipText, "")
    Call PropBag.WriteProperty("BackColorCombo", cmb.BackColor, &H80000005)
    Call PropBag.WriteProperty("ForeColorCombo", cmb.ForeColor, &H80000008)
    Call PropBag.WriteProperty("Dropped", m_Dropped, m_def_Dropped)
End Sub
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
'    m_Dropped = m_def_Dropped
    m_Dropped = m_def_Dropped
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,2,False
Public Property Get Dropped() As Boolean
Attribute Dropped.VB_MemberFlags = "400"
    Dropped = SendMessage(cmb.hwnd, CB_GETDROPPEDSTATE, 0, 0)
End Property
Public Property Let Dropped(ByVal New_Dropped As Boolean)
    If Ambient.UserMode = False Then Err.Raise 387
    SendMessage cmb.hwnd, CB_SHOWDROPDOWN, -New_Dropped, 0
    If New_Dropped Then cmb.SetFocus
    PropertyChanged "Dropped"
End Property
Private Sub cmb_Click()
    txt.Text = cmb.Text
    RaiseEvent ItemSelect
End Sub
