VERSION 5.00
Begin VB.UserControl XButton 
   ClientHeight    =   1170
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3630
   HasDC           =   0   'False
   MousePointer    =   99  'Custom
   ScaleHeight     =   1170
   ScaleWidth      =   3630
   Begin VB.PictureBox pic_hwnd 
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   0
      ScaleHeight     =   375
      ScaleWidth      =   2895
      TabIndex        =   0
      Top             =   0
      Width           =   2895
      Begin VB.Label lbl_Link 
         Height          =   255
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Width           =   2655
      End
   End
   Begin VB.Timer tmr_Mouse 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   3120
      Top             =   0
   End
End
Attribute VB_Name = "XButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private bMouseOver As Boolean

'Default Property Values:
Const m_def_BackColor = &H8000000F
Const m_def_ForeColor = &H0&
Const m_def_BackColorOver = &H808080F
Const m_def_ForeColorOver = &H0&
Const m_def_URL = ""

'Property Variables:
Dim m_BackColor As OLE_COLOR
Dim m_ForeColor As OLE_COLOR
Dim m_BackColorOver As OLE_COLOR
Dim m_ForeColorOver As OLE_COLOR
Dim m_URL As String

'Event Declarations:
Event Click() 'MappingInfo=lbl_Link,lbl_Link,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=lbl_Link,lbl_Link,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lbl_Link,lbl_Link,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lbl_Link,lbl_Link,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=lbl_Link,lbl_Link,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

'mouse checking routines
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = lbl_Link.Enabled
End Property
Public Property Let Enabled(ByVal New_Enabled As Boolean)
    lbl_Link.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = lbl_Link.Font
End Property
Public Property Set Font(ByVal New_Font As Font)
    Set lbl_Link.Font = New_Font
    PropertyChanged "Font"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = lbl_Link.BorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    lbl_Link.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property
Private Sub MouseOut()
bMouseOver = False
Refresh
End Sub
Private Sub MouseOver()
bMouseOver = True
Refresh
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
lbl_Link.Refresh
With lbl_Link
    If bMouseOver Then
        .BackColor = BackColorOver
        .ForeColor = ForeColorOver
        tmr_Mouse.Enabled = True
    Else
        .BackColor = BackColor
        .ForeColor = ForeColor
        tmr_Mouse.Enabled = False
    End If
End With
End Sub
Private Sub ResizeControl()
Width = lbl_Link.Width
Height = lbl_Link.Height
End Sub
Private Sub ResizeLabel()
If AutoSize Then
    ResizeControl
Else
    lbl_Link.Width = Width
    lbl_Link.Height = Height
    pic_hwnd.Width = Width
    pic_hwnd.Height = Height
End If
End Sub
Private Sub lbl_Link_Change()
If AutoSize Then
    Width = lbl_Link.Width
    Height = lbl_Link.Height
End If
End Sub
Private Sub lbl_Link_Click()
    If URL <> "" Then ShellExecute 0, "open", URL, 0, 0, 1
    RaiseEvent Click
End Sub
Private Sub lbl_Link_DblClick()
    RaiseEvent DblClick
End Sub
Private Sub lbl_Link_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub
Private Sub lbl_Link_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
    MouseOver
End Sub
Private Sub lbl_Link_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,AutoSize
Public Property Get AutoSize() As Boolean
Attribute AutoSize.VB_Description = "Determines whether a control is automatically resized to display its entire contents."
    AutoSize = lbl_Link.AutoSize
End Property
Public Property Let AutoSize(ByVal New_AutoSize As Boolean)
    lbl_Link.AutoSize() = New_AutoSize
        
    If New_AutoSize Then ResizeControl
    
    PropertyChanged "AutoSize"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,Alignment
Public Property Get Alignment() As Integer
Attribute Alignment.VB_Description = "Returns/sets the alignment of a CheckBox or OptionButton, or a control's text."
    Alignment = lbl_Link.Alignment
End Property
Public Property Let Alignment(ByVal New_Alignment As Integer)
    lbl_Link.Alignment() = New_Alignment
    PropertyChanged "Alignment"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,Appearance
Public Property Get Appearance() As Integer
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
    Appearance = lbl_Link.Appearance
End Property
Public Property Let Appearance(ByVal New_Appearance As Integer)
    lbl_Link.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
    ToolTipText = lbl_Link.ToolTipText
End Property
Public Property Let ToolTipText(ByVal New_ToolTipText As String)
    lbl_Link.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,WordWrap
Public Property Get WordWrap() As Boolean
Attribute WordWrap.VB_Description = "Returns/sets a value that determines whether a control expands to fit the text in its Caption."
    WordWrap = lbl_Link.WordWrap
End Property
Public Property Let WordWrap(ByVal New_WordWrap As Boolean)
    lbl_Link.WordWrap() = New_WordWrap
    PropertyChanged "WordWrap"
End Property
Private Sub tmr_Mouse_Timer()
Dim hwnd As Long

Dim pt As POINTAPI
GetCursorPos pt
hwnd = WindowFromPoint(pt.X, pt.Y)

If hwnd <> pic_hwnd.hwnd Then MouseOut
End Sub
'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_URL = m_def_URL
    m_BackColor = m_def_BackColor
    m_ForeColor = m_def_ForeColor
    m_BackColorOver = m_def_BackColorOver
    m_ForeColorOver = m_def_ForeColorOver
End Sub

Private Sub UserControl_Paint()
Refresh
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    lbl_Link.Enabled = PropBag.ReadProperty("Enabled", True)
    Set lbl_Link.Font = PropBag.ReadProperty("Font", Ambient.Font)
    lbl_Link.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    lbl_Link.AutoSize = PropBag.ReadProperty("AutoSize", False)
    lbl_Link.Alignment = PropBag.ReadProperty("Alignment", 0)
    lbl_Link.Appearance = PropBag.ReadProperty("Appearance", 1)
    lbl_Link.ToolTipText = PropBag.ReadProperty("ToolTipText", "")
    lbl_Link.WordWrap = PropBag.ReadProperty("WordWrap", False)
    lbl_Link.Caption = PropBag.ReadProperty("Caption", "")
    m_URL = PropBag.ReadProperty("URL", m_def_URL)
    m_BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    m_BackColorOver = PropBag.ReadProperty("BackColorOver", m_def_BackColorOver)
    m_ForeColorOver = PropBag.ReadProperty("ForeColorOver", m_def_ForeColorOver)
End Sub
Private Sub UserControl_Resize()
ResizeLabel
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Enabled", lbl_Link.Enabled, True)
    Call PropBag.WriteProperty("Font", lbl_Link.Font, Ambient.Font)
    Call PropBag.WriteProperty("BorderStyle", lbl_Link.BorderStyle, 0)
    Call PropBag.WriteProperty("AutoSize", lbl_Link.AutoSize, False)
    Call PropBag.WriteProperty("Alignment", lbl_Link.Alignment, 0)
    Call PropBag.WriteProperty("Appearance", lbl_Link.Appearance, 1)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
    Call PropBag.WriteProperty("ToolTipText", lbl_Link.ToolTipText, "")
    Call PropBag.WriteProperty("WordWrap", lbl_Link.WordWrap, False)
    Call PropBag.WriteProperty("Caption", lbl_Link.Caption, "")
    Call PropBag.WriteProperty("URL", m_URL, m_def_URL)
    Call PropBag.WriteProperty("BackColor", m_BackColor, m_def_BackColor)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("BackColorOver", m_BackColorOver, m_def_BackColorOver)
    Call PropBag.WriteProperty("ForeColorOver", m_ForeColorOver, m_def_ForeColorOver)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lbl_Link,lbl_Link,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
    Caption = lbl_Link.Caption
End Property
Public Property Let Caption(ByVal New_Caption As String)
    lbl_Link.Caption() = New_Caption
    
    PropertyChanged "Caption"
End Property
Public Property Get URL() As String
    URL = m_URL
End Property
Public Property Let URL(ByVal New_URL As String)
    m_URL = New_URL
    PropertyChanged "URL"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H8000000F&
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = m_BackColor
End Property
Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_BackColor = New_BackColor
    PropertyChanged "BackColor"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H00000000&
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = m_ForeColor
End Property
Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H8000000F&
Public Property Get BackColorOver() As OLE_COLOR
    BackColorOver = m_BackColorOver
End Property
Public Property Let BackColorOver(ByVal New_BackColorOver As OLE_COLOR)
    m_BackColorOver = New_BackColorOver
    PropertyChanged "BackColorOver"
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,&H00FF0000&
Public Property Get ForeColorOver() As OLE_COLOR
    ForeColorOver = m_ForeColorOver
End Property
Public Property Let ForeColorOver(ByVal New_ForeColorOver As OLE_COLOR)
    m_ForeColorOver = New_ForeColorOver
    PropertyChanged "ForeColorOver"
End Property
